#!/usr/bin/perl
# search.cgi simple frontend to swish generated index
# cd /var/www/swish; swish-e -c swish.conf
# Written:       Neville Richter 26/11/2001 Version 1.0
# Modified:      Mark Huth        9/01/2002 Version 1.1
# Modified:	 Neville Richter 11/01/2002 Version 1.2
#############################################################

require("cgi-lib.pl");
&ReadParse(*in);
print &PrintHeader;

$self = "search.cgi";
$cgi = "/cgi-bin/$self";
$root = "/var/www/swish/";
$pagesize = 20;
@out = `ls $root`;

if ($ENV{"QUERY_STRING"} =~ /[;\|\\`]/)
{ print "<h1>Sorry</h1>"; exit (1); }

if ($ENV{'QUERY_STRING'} eq "")
{
  print "<HTML><HEAD><TITLE>Search</TITLE></HEAD>\n";
  print "<BODY><H2>Search</H2><HR>\n";
  print "<form method=get action=$cgi>\n";
  print "keyword <input type=text name=keyword> in \n";
  foreach $line (@out)
  {
     chop ($line);
     print "<option value=$line>$line\n";
  }
  print "</select>\n";
  print "<input type=submit name=search> </form>\n";

}
elsif ($ENV{'QUERY_STRING'} =~ /keyword=/)
{
  $keyword="$in{'keyword'}";
  print "<HTML><HEAD><TITLE>Search results for $keyword</TITLE></HEAD>\n";
  print "<BODY><H2>Search results for <font color=red>$keyword</font></H2>\n";

  @out=`/usr/bin/swish-e -f $root/index.swish -w $keyword`;
  $count=0;
  print "<table width=100% border=0>\n";
  print "<tr bgcolor=darkblue>\n";
  print "  <th width=10%><font color=white>Rank</font></th>\n";
  print "  <th width=75%><font color=white>Document Title</font></th>\n";
  print "  <th width=15%><font color=white>Size</font></th>\n";
  print "</tr>\n";
  $linecount=0;
  foreach $line (@out)
  {
    chop ($line);
    if ( $line =~ /search words: / ) {
# 
    } elsif ( $line =~ /^\./ ) {
# strip of comments
    } elsif ( $line =~ /^#/ ) {
# debug      print ("$line<br>\n");
    } else { 
      $count++;
      ($args,$title,$size) = split(/"/,$line);
      ($rank,$url)=split(/ /,$args);
# some rating
      if ( $rank > 900 )    { $stars = 5; }
      elsif ( $rank > 700 ) { $stars = 4; }
      elsif ( $rank > 500 ) { $stars = 3; }
      elsif ( $rank > 300 ) { $stars = 2; }
      else { $stars = 1; }

      if ($count <= $pagesize) {
	if ($linecount%2) {
	  print "<tr bgcolor=white>\n";
	} else {
	  print "<tr bgcolor=whitesmoke>\n";
	}
	print "  <td align=right>";
	while ($stars > 0) {
	  print "<img src=/icons/star1.gif width=12 height=12>";
	  $stars--
	}
	print "  </td>\n";
	print "  <td><a href=$url>$title</a></td>\n";
	print "  <td align=right>$size bytes</td>\n";
	print "</tr>\n";
	$linecount++

#        print ("<a href=$url>$title</a> $size bytes <font color=red>$star</font><br>\n");
      }
    }
  }
  print "</table>\n";
}

# --------------------------- display some closing info...

print "<HR>Return to <a href=$cgi>$self</a> home page, simple frontend to swish generated index<br>\n";
print "<I><a href=/cgi-src/$self>$self</a> is maintained by "; 
print "<a href=mailto:n.richter\@qut.edu.au>N. Richter</a> &copy; QUT 2001</I><br>\n";
print "Example <a href=/manual/swish.conf>swish.conf</a> of the Apache manual.\n";
print "</BODY></HTML>";

